'use strict';

/* jshint ignore:start */
/**
 * This code was generated by
 * \ / _    _  _|   _  _
 *  | (_)\/(_)(_|\/| |(/_  v1.0.0
 *       /       /
 */
/* jshint ignore:end */

var Q = require('q');  /* jshint ignore:line */
var _ = require('lodash');  /* jshint ignore:line */
var Page = require('../../../../../../base/Page');  /* jshint ignore:line */
var values = require('../../../../../../base/values');  /* jshint ignore:line */

var StepContextList;
var StepContextPage;
var StepContextInstance;
var StepContextContext;

/* jshint ignore:start */
/**
 * @constructor Twilio.Studio.V1.FlowContext.EngagementContext.StepContext.StepContextList
 * @description Initialize the StepContextList
 * PLEASE NOTE that this class contains beta products that are subject to change. Use them with caution.
 *
 * @param {Twilio.Studio.V1} version - Version of the resource
 * @param {string} flowSid - The flow_sid
 * @param {string} engagementSid - The engagement_sid
 * @param {string} stepSid - The step_sid
 */
/* jshint ignore:end */
StepContextList = function StepContextList(version, flowSid, engagementSid,
                                            stepSid) {
  /* jshint ignore:start */
  /**
   * @function stepContext
   * @memberof Twilio.Studio.V1.FlowContext.EngagementContext.StepContext
   * @instance
   *
   * @param {string} sid - sid of instance
   *
   * @returns {Twilio.Studio.V1.FlowContext.EngagementContext.StepContext.StepContextContext}
   */
  /* jshint ignore:end */
  function StepContextListInstance(sid) {
    return StepContextListInstance.get(sid);
  }

  StepContextListInstance._version = version;
  // Path Solution
  StepContextListInstance._solution = {
    flowSid: flowSid,
    engagementSid: engagementSid,
    stepSid: stepSid
  };
  /* jshint ignore:start */
  /**
   * Constructs a step_context
   *
   * @function get
   * @memberof Twilio.Studio.V1.FlowContext.EngagementContext.StepContext.StepContextList
   * @instance
   *
   * @returns {Twilio.Studio.V1.FlowContext.EngagementContext.StepContext.StepContextContext}
   */
  /* jshint ignore:end */
  StepContextListInstance.get = function get() {
    return new StepContextContext(
      this._version,
      this._solution.flowSid,
      this._solution.engagementSid,
      this._solution.stepSid
    );
  };

  return StepContextListInstance;
};


/* jshint ignore:start */
/**
 * @constructor Twilio.Studio.V1.FlowContext.EngagementContext.StepContext.StepContextPage
 * @augments Page
 * @description Initialize the StepContextPage
 * PLEASE NOTE that this class contains beta products that are subject to change. Use them with caution.
 *
 * @param {Twilio.Studio.V1} version - Version of the resource
 * @param {object} response - Response from the API
 * @param {object} solution - Path solution
 *
 * @returns StepContextPage
 */
/* jshint ignore:end */
StepContextPage = function StepContextPage(version, response, solution) {
  // Path Solution
  this._solution = solution;

  Page.prototype.constructor.call(this, version, response, this._solution);
};

_.extend(StepContextPage.prototype, Page.prototype);
StepContextPage.prototype.constructor = StepContextPage;

/* jshint ignore:start */
/**
 * Build an instance of StepContextInstance
 *
 * @function getInstance
 * @memberof Twilio.Studio.V1.FlowContext.EngagementContext.StepContext.StepContextPage
 * @instance
 *
 * @param {object} payload - Payload response from the API
 *
 * @returns StepContextInstance
 */
/* jshint ignore:end */
StepContextPage.prototype.getInstance = function getInstance(payload) {
  return new StepContextInstance(
    this._version,
    payload,
    this._solution.flowSid,
    this._solution.engagementSid,
    this._solution.stepSid
  );
};


/* jshint ignore:start */
/**
 * @constructor Twilio.Studio.V1.FlowContext.EngagementContext.StepContext.StepContextInstance
 * @description Initialize the StepContextContext
 * PLEASE NOTE that this class contains beta products that are subject to change. Use them with caution.
 *
 * @property {string} accountSid - The account_sid
 * @property {string} context - The context
 * @property {string} engagementSid - The engagement_sid
 * @property {string} flowSid - The flow_sid
 * @property {string} stepSid - The step_sid
 * @property {string} url - The url
 *
 * @param {Twilio.Studio.V1} version - Version of the resource
 * @param {object} payload - The instance payload
 * @param {sid} flowSid - The flow_sid
 * @param {sid} engagementSid - The engagement_sid
 * @param {sid} stepSid - The step_sid
 */
/* jshint ignore:end */
StepContextInstance = function StepContextInstance(version, payload, flowSid,
                                                    engagementSid, stepSid) {
  this._version = version;

  // Marshaled Properties
  this.accountSid = payload.account_sid; // jshint ignore:line
  this.context = payload.context; // jshint ignore:line
  this.engagementSid = payload.engagement_sid; // jshint ignore:line
  this.flowSid = payload.flow_sid; // jshint ignore:line
  this.stepSid = payload.step_sid; // jshint ignore:line
  this.url = payload.url; // jshint ignore:line

  // Context
  this._context = undefined;
  this._solution = {flowSid: flowSid, engagementSid: engagementSid, stepSid: stepSid, };
};

Object.defineProperty(StepContextInstance.prototype,
  '_proxy', {
  get: function() {
    if (!this._context) {
      this._context = new StepContextContext(
        this._version,
        this._solution.flowSid,
        this._solution.engagementSid,
        this._solution.stepSid
      );
    }

    return this._context;
  }
});

/* jshint ignore:start */
/**
 * fetch a StepContextInstance
 *
 * @function fetch
 * @memberof Twilio.Studio.V1.FlowContext.EngagementContext.StepContext.StepContextInstance
 * @instance
 *
 * @param {function} [callback] - Callback to handle processed record
 *
 * @returns {Promise} Resolves to processed StepContextInstance
 */
/* jshint ignore:end */
StepContextInstance.prototype.fetch = function fetch(callback) {
  return this._proxy.fetch(callback);
};

/* jshint ignore:start */
/**
 * Produce a plain JSON object version of the StepContextInstance for serialization.
 * Removes any circular references in the object.
 *
 * @function toJSON
 * @memberof Twilio.Studio.V1.FlowContext.EngagementContext.StepContext.StepContextInstance
 * @instance
 *
 * @returns Object
 */
/* jshint ignore:end */
StepContextInstance.prototype.toJSON = function toJSON() {
  let clone = {};
  _.forOwn(this, function(value, key) {
    if (!_.startsWith(key, '_') && ! _.isFunction(value)) {
      clone[key] = value;
    }
  });
  return clone;
};


/* jshint ignore:start */
/**
 * @constructor Twilio.Studio.V1.FlowContext.EngagementContext.StepContext.StepContextContext
 * @description Initialize the StepContextContext
 * PLEASE NOTE that this class contains beta products that are subject to change. Use them with caution.
 *
 * @param {Twilio.Studio.V1} version - Version of the resource
 * @param {sid} flowSid - The flow_sid
 * @param {sid} engagementSid - The engagement_sid
 * @param {sid} stepSid - The step_sid
 */
/* jshint ignore:end */
StepContextContext = function StepContextContext(version, flowSid,
                                                  engagementSid, stepSid) {
  this._version = version;

  // Path Solution
  this._solution = {flowSid: flowSid, engagementSid: engagementSid, stepSid: stepSid, };
  this._uri = _.template(
    '/Flows/<%= flowSid %>/Engagements/<%= engagementSid %>/Steps/<%= stepSid %>/Context' // jshint ignore:line
  )(this._solution);
};

/* jshint ignore:start */
/**
 * fetch a StepContextInstance
 *
 * @function fetch
 * @memberof Twilio.Studio.V1.FlowContext.EngagementContext.StepContext.StepContextContext
 * @instance
 *
 * @param {function} [callback] - Callback to handle processed record
 *
 * @returns {Promise} Resolves to processed StepContextInstance
 */
/* jshint ignore:end */
StepContextContext.prototype.fetch = function fetch(callback) {
  var deferred = Q.defer();
  var promise = this._version.fetch({uri: this._uri, method: 'GET'});

  promise = promise.then(function(payload) {
    deferred.resolve(new StepContextInstance(
      this._version,
      payload,
      this._solution.flowSid,
      this._solution.engagementSid,
      this._solution.stepSid
    ));
  }.bind(this));

  promise.catch(function(error) {
    deferred.reject(error);
  });

  if (_.isFunction(callback)) {
    deferred.promise.nodeify(callback);
  }

  return deferred.promise;
};

module.exports = {
  StepContextList: StepContextList,
  StepContextPage: StepContextPage,
  StepContextInstance: StepContextInstance,
  StepContextContext: StepContextContext
};
